; AutoLeech.Install       Installation of AUTOLEECH 99
; build 24.22             requires mIRC 6.01 (5.91, 5.71, 5.82 & 5.9)

; thanks to all users who have contributed suggestions & comments

; Special thanks to burnin for the AL99 logo
; AUTOLEECH by TomT


alias AL_Install {
  unset %AL^InstallC
  if ( [ $version $+ , ] !isin 5.71,5.82,5.9,5.91,6.01,) { beep | if ($?!="N O T I C E $crlf $crlf $+ AUTOLEECH 99.24.22 has been somewhat tested with mIRC 5.71, 5.82, 5.9, 5.91 & 6.01. No multi-server testing has been done for versions 6.0 & greater! You are using mIRC $version $crlf $crlf $+ Continue installation anyway? $iif($version < 5.7, $crlf -Not recommended-, $crlf ) " = $false) { .unload -rs al_install.mrc | halt } }
  .timer 1 1 /$AL_InstallIntro
}

alias AL_InstallIntro {
  if (($lock(run)) || ($lock(dll))) { $?!="AUTOLEECH 99 $crlf $crlf $+ Please note: it is NECESSARY that you goto mIRC Options, then General, then Lock and UNCHECK the box beside /run & /dll $crlf $crlf $+ Session ENDING!" = $false) halt | halt }
  if ($isdir(autoleech)) { set %InstallD AUTOLEECH 99 updates $crlf $crlf $+ No multi-server testing has been done for versions 6.0 & greater! $crlf $crlf $+ Resolved double counting error $crlf $crlf $+ Added ability to leech csvs with commas in filenames $crlf $crlf $+ Can scroll AutoSnag window by press alpha characters $crlf $crlf $+ .z files will be auto changed to .zip $crlf $crlf $+ New menu selection to make a trigger of any collection you are leeching $crlf $crlf $+ New ECSV options, allowing you to request and/or store files with or without ECSV paths $crlf $crlf $+ A few other bugfixes | set %InstallX 1 | $dialog(al_install,al_install,-4) | unset %InstallX | if (%AL^InstallC) halt }
  set %InstallD Interaction between AUTOLEECH 99 and other scripts you may be using can not be ruled out.  Precautions have been taken to avoid script interaction, however all circumstances can not be accounted for.  It is strongly recommended that you make a copy of your existing mirc folder so you can restore to your previous setup in the event of an installation or operational conflict. | $dialog(al_install,al_install,-4) | if (%AL^InstallC) halt
  dialog -ma AL_install AL_install
  .timer 1 0 /$AL_Install1
}

alias AL_Install1 {
  did -ra al_install 10 | did -hra al_install 20 Done | did -h al_install 30 | unset %InstallD
  did -a al_install 10 $crlf $+ Installation beginning
  did -a al_install 10 $crlf $+ Closing open windows
  window -c @AutoLeech | window -c @AutoGet | window -c @AutoSnag | window -c @AutoList
  if ($dialog(AL_csv)) dialog -x AL_csv
  if ($dialog(autoget)) dialog -x autoget
  if ($dialog(AL_sessionmgr)) dialog -x AL_sessionmgr
  did -a al_install 10 $crlf $+ Turning off timers
  .timergets* off
  did -a al_install 10 $crlf $+ AL Windows CLOSED, Timers OFF
  unset %AL^* %AL_ %AG_* %ALK_*
  did -a al_install 10 $crlf $+ AL Variables have been removed

  ctcps on | events on
  set %Install 1

  did -a al_install 10 $crlf $+ Checking for Backup folder
  if ($finddir($mircdir,Backup,1) = $null) { mkdir Backup | did -a al_install 10 $crlf $+ Backup folder created }
  else did -a al_install 10 $crlf $+ Backup folder intact

  did -a al_install 10 $crlf $+ Checking for AUTOLEECH folder
  if ($isdir(AutoLeech) = $false) { mkdir AutoLeech | did -a al_install 10 $crlf $+ AutoLeech folder created }
  else did -a al_install 10 $crlf $+ AutoLeech folder intact
  did -a al_install 10 $crlf $+ Checking for AGR_Files folder
  if ($isdir(autoleech\AGR_Files) = $false) { mkdir AutoLeech\AGR_Files | did -a al_install 10 $crlf $+ AGR_Files folder created }
  else did -a al_install 10 $crlf $+ AGR_Files folder intact
  if ($version > 5.6) {
    did -a al_install 10 $crlf $+ Checking for TrigLists folder
    if ($isdir(autoleech\TrigLists) = $false) { mkdir AutoLeech\TrigLists | did -a al_install 10 $crlf $+ TrigLists folder created }
    else did -a al_install 10 $crlf $+ TrigLists folder intact
  }

  did -a al_install 10 $crlf $+ Checking for existing AUTOLEECH scripts  
  window -c @Install | window -hl @Install
  if ($script(0)) { set %AL^IC1 0 | :loopf1 | inc %AL^IC1 | aline @Install $script(%AL^IC1) | if (%AL^IC1 < $script(0)) goto loopf1 }
  set %AL^T1 0 | set %AL^IC 0 | :loop2 | inc %AL^IC
  if ((AL*.mrc iswm $nopath($line(@Install,%AL^IC))) || (AG*.mrc iswm $nopath($line(@Install,%AL^IC)))) {
    set %AL^T " $+ $line(@Install,%AL^IC) $+ "
    if (AL_install.mrc !isin %AL^T) {
      set %AL^T2 1
      .unload -rs %AL^T | inc %AL^T1
      did -a al_install 10 $crlf $+ Unloaded: %AL^T
      if ($exists($line(@Install,%AL^IC))) { .copy -o %AL^T backup\ $+ $replace($nopath($line(@Install,%AL^IC)),.mrc,.old) | .remove %AL^T }
  } }
  if (%AL^IC < $line(@Install,0)) goto loop2 | window -c @Install
  if (%AL^T2) did -a al_install 10 $crlf $+ Old AUTOLEECH scripts removed
  else did -a al_install 10 $crlf $+ No old AUTOLEECH scripts found

  :Rloop | if ($findfile($mircdir [ $+  [ autoleech ] ] ,*.mrc,1)) { inc %AL^T1 | .copy -o " $+ $ifmatch $+ " backup\ $+ $replace($nopath($ifmatch),.mrc,.old) | .remove " $+ $ifmatch $+ " | goto Rloop }

  did -a al_install 10 $crlf $+ Checking for AL_Data1.dat
  if ($exists(autoleech\AL_Data1.dat)) { inc %AL^T1 | .copy -o autoleech\AL_Data1.dat backup\AL_Data1.old | .remove autoleech\AL_Data1.dat | did -a al_install 10 $crlf $+ Saving: AL_Data1.old | set %Install 0 }

  did -a al_install 10 $crlf $+ Checking for AL_Data2.dat
  if ($exists(autoleech\AL_Data2.dat)) { inc %AL^T1 | .copy -o autoleech\AL_Data2.dat backup\AL_Data2.old | .remove autoleech\AL_Data2.dat | did -a al_install 10 $crlf $+ Saving: AL_Data2.old }

  if (%AL^T1) did -a al_install 10 $crlf $+ Backup of %AL^T1 files complete
  else did -a al_install 10 $crlf $+ No outdated files found

  .rename AL_Data1.da_ autoleech\AL_Data1.dat
  .rename AL_Data2.da_ autoleech\AL_Data2.dat

  if (($exists(backup\AL_data1.old)) && (%InstallY != 1)) {
    did -a al_install 10 $crlf $+ AL_Data1.dat Checking
    .copy -o backup\AL_Data1.old autoleech\AL_Data1.dat
    did -a al_install 10 $crlf $+ AL_Data1.dat OK
    set %AL^Install
  }
  else did -a al_install 10 $crlf $+ AL_Data1.dat Created
  if ($lines(autoleech\AL_data1.dat) = 100) write -l101 autoleech\AL_data1.dat 001111111000000111110
  set %AL_TST $read -nl101 autoleech\al_data1.dat

  if (($exists(backup\AL_data2.old)) && (%InstallY != 1)) {
    did -a al_install 10 $crlf $+ AL_Data2.dat Checking
    .copy -o backup\AL_Data2.old autoleech\AL_Data2.dat
    did -a al_install 10 $crlf $+ AL_Data2.dat OK
    set %AL^Install
  }
  else did -a al_install 10 $crlf $+ AL_Data2.dat Created

  did -a al_install 10 $crlf $+ Moving NEW support files
  if ($exists(AL_UnInstall.mr_)) { .copy -o AL_UnInstall.mr_ autoleech\AL_UnInstall.mrc | .remove AL_UnInstall.mr_ }
  if ($exists(AL_Document.htm)) { .copy -o AL_Document.htm autoleech\AL_Document.htm | .remove AL_Document.htm }
  if ($exists(AL_Versions.tx_)) { .copy -o AL_Versions.tx_ AL_Versions.txt | .remove AL_Versions.tx_ }
  if ($exists(AL_Config.da_)) { .copy -o AL_Config.da_ autoleech\AL_Config.dat | .remove AL_Config.da_ }
  if ($exists(AL.bmp)) { if ($exists(autoleech\AL.bmp) = $false) .copy -o AL.bmp autoleech\AL.bmp | .remove AL.bmp }
  did -a al_install 10 $crlf $+ NEW support files located

  did -a al_install 10 $crlf $+ Moving NEW script files
  if ($exists(AL_1.mr_)) .rename AL_1.mr_ autoleech\AL_1.mrc
  if ($exists(AL_2.mr_)) .rename AL_2.mr_ autoleech\AL_2.mrc
  if ($exists(AL_Session.mr_)) .rename AL_Session.mr_ autoleech\AL_Session.mrc
  if ($exists(AL_Options.mr_)) .rename AL_Options.mr_ autoleech\AL_Options.mrc
  if ($exists(AL_Config.da_)) .rename AL_Config.da_ autoleech\AL_Config.dat
  did -a al_install 10 $crlf $+ NEW script files located

  did -a al_install 10 $crlf $+ Loading AUTOLEECH script files
  .load -rs autoleech\AL_1.mrc | did -a al_install 10 $crlf $+ Loaded: autoleech\AL_1.mrc
  .load -rs autoleech\AL_2.mrc | did -a al_install 10 $crlf $+ Loaded: autoleech\AL_2.mrc
  did -a al_install 10 $crlf $+ AUTOLEECH script files loaded

  did -a al_install 10 $crlf $+ Upgrading system data
  $AL_Default
  did -a al_install 10 $crlf $+ System data upgraded

  did -a al_install 10 $crlf $+ Updating AUTOLEECH Version
  $AL_sD1(0,1,9,AutoLeech 99.24.22)
  did -a al_install 10 $crlf $+ AUTOLEECH Version updated

  did -a al_install 10 $crlf $+ Unloading install script
  if ($exists(AL_install.mrc)) { .rename AL_install.mrc autoleech\AL_Install.mrc }
  did -a al_install 10 $crlf $+ Installation COMPLETE!
  did -fv AL_install 20
}

; ***** routine used to set up default variables

alias AL_Default {
  if ($AL_D1(0,2,9) = $null) $AL_sD1(0,2,9,$getdir(*.txt))
  if ($AL_D1(0,2,2) = 0) $AT_D1(0,2,2,1)
  if ($AL_D1(0,2,3) = 0) $AT_D1(0,2,3,28.8k)
  if ($AL_D1(0,10,9) = $null) $AL_sD1(0,10,9,150)
  if (($AL_S(19)) && ($version < 5.61)) $AL_sS(19,-47)
  if (($AL_S(20)) && ($version < 5.61)) $AL_sS(20,-47)
  if ($AL_S(21) = $null) $AL_sS(21,$iif($sreq = auto,0,1))

  ;ver 17.05
  if ($gettok($AL_D1(0,1,9),2,32) < 99.17.05) {
    did -a al_install 10 $crlf $+ Installing version 17.05 specific updates
    $AL_sS(13,$iif($exists(C:\Program Files\ACD Systems\ACDSee\ACDSee.exe),1,0))
    if ((%Install) || (%InstallY)) goto end
    $AL_sS(1,$ALx_D1oo(0,1,2)) | $AL_sD1(0,1,2,)
    $AL_sS(2,$ALx_D1oo(0,1,8)) | $AL_sD1(0,1,8,)
    $AL_sS(3,$ALx_D1oo(0,2,1)) | $AL_sD1(0,2,1,)
    $AL_sS(4,$ALx_D1oo(0,2,4)) | $AL_sD1(0,2,4,)
    $AL_sS(5,$ALx_D1oo(0,3,1)) | $AL_sD1(0,3,1,)
    $AL_sS(15,$AL_D1(0,2,6)) | $AL_sD1(0,2,6,)
    $AL_sD1(0,2,5,)
    :end
  }
  ;ver 18.05
  if ($gettok($AL_D1(0,1,9),2,32) < 99.18.05) {
    $AL_sS(22,1)
  }
  ;ver 24.14m
  if ($gettok($AL_D1(0,1,9),2,32) < 99.24.14m) {
    if ($exists(C:\Program Files\ACD Systems\ACDSee\ACDSee.exe)) $AL_sD1(3,6,C:\Program Files\ACD Systems\ACDSee\ACDSee.exe)
} } }

; ***** routines to control info in and out of AL_Data files
alias ALx_D1 {
  if ($2 != %ALx_T1Last) { set %ALx_T1Tmp $read -nl [ $+ [ $2 ] ] backup\AL_Data1.old | set %ALx_T1Last $2 }
  if ($1 < 2) return $gettok(%ALx_T1Tmp,$1,44)
  else return $remove($gettok(%ALx_T1Tmp,2-,44),$chr(0160))
}
alias ALx_D2 {
  if ($2 != %ALx_T2Last) { set %ALx_T2Tmp $read -nl [ $+ [ $2 ] ] backup\AL_Data2.old | set %ALx_T2Last $2 }
  if ($1 < 5) return $remove($gettok(%ALx_T2Tmp,$1,44),$chr(0160))
  else return $remove($gettok(%ALx_T2Tmp,5-,44),$chr(0160))
}
alias ALx_sD1 {
  if ($2 != %ALx_T1Last) { set %ALx_T1Tmp $read -nl [ $+ [ $2 ] ] autoleech\AL_Data1.dat | set %ALx_T1Last $2 }
  if ($1 == 1) set %ALx_T1Tmp $puttok(%ALx_T1Tmp,$3,1,44)
  else set %ALx_T1Tmp $gettok(%ALx_T1Tmp,1,44) $+ $chr(44) $+ $3-
  write -l [ $+ [ $2 ] ] autoleech\AL_Data1.dat %AL^T1Tmp | return
}
alias ALx_sD2 {
  if ($2 != %ALx_T2Last) { set %ALx_T2Tmp $read -nl [ $+ [ $2 ] ] autoleech\AL_Data2.dat | set %ALx_T2Last $2 }
  if ($1 isnum 1-4) set %ALx_T2Tmp $puttok(%ALx_T2Tmp,$3-,$1,44)
  else set %AL^T2Tmp $gettok(%ALx_T2Tmp,1-4,44) $+ $chr(44) $+ $3-
  write -l [ $+ [ $2 ] ] autoleech\AL_Data2.dat %ALx_T2Tmp | return
}
alias ALx_3 { return $str($chr(0160),3) }
alias ALx_D1oo return $iif($AL_D1($1,$2,$3) = OFF,0,1)

dialog AL_Install {
  size -1 -1 300 340
  box "",5,10 0 280 120
  edit "",10,10 130 280 150,multi read vsbar
  button "Next",20,115 290 70 25,ok
  button "Abort",30,210 290 70 25,cancel
  icon 40,5 20 290 90,al.bmp
  check "Save settings and data from previous installation",50,20 320 270 20
}
on *:dialog:al_install:init:0:{
  did $iif(%InstallX,-cv,-ch) al_install 50
  dialog -t al_install AutoLeech 99.24.22 Installation
  did -ra al_install 10 %InstallD
  did -f al_install 20
}
on *:dialog:al_install:sclick:*:{
  if ($did = 50) { set %InstallY $iif($did(al_install,50).state = 0,1,0) | if (%InstallY) beep 10 10 | halt }
  if ($did isin 20 30) {
    if ($did = 30) goto done
    if (%InstallD) goto end
    if (%Install) $AL_DLaunch(Options)
    dialog -m al_about al_about
    :done
    unset %AL^I* %Install*
    dialog -x al_install
    if ($did = 30) set %AL^InstallC 1
    .timer 1 0 /.unload -rs al_install.mrc
  }
  halt
  :end | unset %AL^T* | dialog -x al_install
}
